uniform sampler2D inputImageTexture;
varying highp vec2 textureCoordinate;
varying lowp float texelHeight;

precision highp float;

float SCurve (float x) {

		x = x * 2.0 - 1.0;
		return -x * abs(x) * 0.5 + x + 0.5;

        //return dot(vec3(-x, 2.0, 1.0 ),vec3(abs(x), x, 1.0)) * 0.5; // possibly faster version

}

vec4 BlurV (sampler2D source, float height, vec2 uv, float radius) {

	if (radius >= 1.0)
	{
		vec4 A = vec4(0.0);
		vec4 C = vec4(0.0);

		//float width = 1.0 / size.x;

		float divisor = 0.0;
        float weight = 0.0;
        float stepSize = 16.0;

        float radiusMultiplier = 1.0 / radius;

        // Hardcoded for radius 20 (normally we input the radius
        // in there), needs to be literal here

		for (float y = -radius; y <= radius; y+=stepSize )
		{
			A = texture2D(source, uv + vec2(0.0, y * height ));

            	weight = SCurve(1.0 - (abs(y) * radiusMultiplier));

            	C += A * weight;

			divisor += weight;
		}

		return vec4(C.rgb / divisor, 1.0);
	}

	return texture2D(source, uv);
}

void main() 
{
	//	gl_FragColor = texture2D(inputImageTexture, textureCoordinate );
	gl_FragColor  = BlurV( inputImageTexture, texelHeight, textureCoordinate, 120.0 );

}
